class CautBinRec {

  /* Metoda de cautare recursiva intro zona de tablou */
  static int cautBinRec(double tab[], double val, int inf, int sup){
   if(inf>sup) return -1; // interval gresit
   int k=(inf+sup)/2; // se ia indicele de la mijlocul zonei
   if(val==tab[k]) return k; // s-a gasit elementul cautat
   if(val<tab[k]) return cautBinRec(tab, val, inf, k-1); /* se cauta
     valoarea val in jumatatea din stanga a zonei */
   else return cautBinRec(tab, val, k+1, sup); /* se cauta valoarea
     val in jumatatea din dreapta a zonei */
  }

  /* Metoda de cautare in intregul tablou */
  static int cautBinRec(double tab[], double val) {
    return cautBinRec(tab, val, 0, tab.length-1);
  }

  /* Testarea celor doua metode de cautare */

  public static void main(String args[]) {
    double t[]={-1.35, 2.146, 7.258, 12.9, 21.43};
    /* se cauta prima si ultima valoare din tablou */
    System.out.println("-1.35 se afla pe pozitia"+
      cautBinRec(t,-1.35));
    System.out.println("21.43 se afla pe pozitia"+
      cautBinRec(t,21.43));
    /* Se cauta elemente de pe pozitii intermediare */
    System.out.println("2.146 se afla pe pozitia"+
      cautBinRec(t,2.146));
    System.out.println("7.258 se afla pe pozitia"+
      cautBinRec(t,7.258));
    System.out.println("12.9 se afla pe pozitia"+
      cautBinRec(t,12.9));
    /* Se cauta valori inexistente */
    System.out.println("-3.055 se afla pe pozitia"+
      cautBinRec(t,-3.055));
    System.out.println("-4.35 se afla pe pozitia"+
      cautBinRec(t,4.35));
    System.out.println("27.9 se afla pe pozitia"+
      cautBinRec(t,27.9));
  }
}
