class TestNumarare {
  public static void main(String args[]) {
    if(args.length<2) {
      System.out.println("Utilizare: java <lungimeNumar> " +
        "<sir cifre separate prin spatii>");
      System.exit(0);
    }
    try {
      int lungimeNumar=Integer.parseInt(args[0]);
      String[] cifre=new String[args.length-1];
      for(int i=1; i<args.length; i++) cifre[i-1]=args[i];
      Numarare numarare=new Numarare(cifre, lungimeNumar);
      String numar;
      do {
        numar=(String)numarare.solutiaUrmatoare();
        if(numar!=null) System.out.println(numar);
      } while(numar!=null);
    }
    catch(Exception e) {
      System.out.println(e);
    }
  }
}
