import java.awt.*;
import java.applet.*;
import java.awt.event.*;

public class Complexitate extends Applet {

  double tab[][]=new double[5][100];
  double xmin=1.0, xmax=3.0, deltax, scaray, ymax;

  public void init() {
    double x;
    setSize(400,210);
    // calcularea tabelei de valori
    deltax=(xmax-xmin)/100.0;
    for(int j=0; j<100; j++) {
      x=xmin+j*deltax;
      tab[0][j]=x;
      tab[1][j]=Math.log(x)+1;
      tab[2][j]=x*Math.log(x)+1;
      tab[3][j]=x*x;
      tab[4][j]=Math.exp(x)-Math.E;
    }
    // Calcularea valorii maxime si a scarii pe y
    ymax=0;
    for (int i=0; i<5; i++) 
      if(tab[i][99]>ymax) ymax=tab[i][99];
    scaray=200/ymax;
  }

  public void paint(Graphics g) {
    int tx[]=new int[100],ty[]=new int[100];
    Color color[]=new Color[5];
    color[0]=Color.black;
    color[1]=Color.green;
    color[2]=Color.magenta;
    color[3]=Color.blue;
    color[4]=Color.red;
    int xi=(int)(200.0/xmax)+5;
    for(int j=0; j<100; j++) tx[j]=xi+(int)(205-xi)*j/100;
    setBackground(Color.white);
    // Trasarea axelor
    g.drawLine(5,205,205,205);
    g.drawLine(5,205,5,5);
    // Trasarea curbelor
    for(int i=0; i<5; i++) {
      for(int j=0; j<100; j++)
        ty[j]=(int)(205.0-tab[i][j]*scaray);
      g.setColor(color[i]);
      g.drawPolyline(tx,ty,100);
      g.drawLine(230, 50+20*i, 250, 50+20*i);
      g.setColor(Color.black);
      g.drawString("Functia", 270, 35);
      g.drawString("n", 270, 55);
      g.drawString("Math.log(n)+1", 270, 75);
      g.drawString("n*Math.log(n)+1", 270,95);
      g.drawString("n*n", 270, 115);
      g.drawString("Math.exp(n)-Math.E", 270, 135);
    }
  }

}
    