import java.util.*;

/* Program de testare a clasei ArboreBinar. Se construieste un
   arbore, care este apoi traversat in preordine, inordine, postordine
   si in latime
*/
class TestArboreBinar {
  public static void main(String args[]) {
    ArboreBinar arbore;
    ArboreBinar.Nod nod1, nod2, nod3;
    nod1=new ArboreBinar.Nod("E");
    nod1.puneFiuStanga(new ArboreBinar.Nod("H"));
    nod2=new ArboreBinar.Nod("B");
    nod2.puneFiuStanga(new ArboreBinar.Nod("D"));
    nod2.puneFiuDreapta(nod1);
    nod1=new ArboreBinar.Nod("A");
    nod1.puneFiuStanga(nod2);
    nod2=new ArboreBinar.Nod("I");
    nod2.puneFiuDreapta(new ArboreBinar.Nod("J"));
    nod3=new ArboreBinar.Nod("F");
    nod3.puneFiuStanga(nod2);
    nod2=new ArboreBinar.Nod("C");
    nod2.puneFiuStanga(nod3);
    nod2.puneFiuDreapta(new ArboreBinar.Nod("G"));
    nod1.puneFiuDreapta(nod2);
    arbore=new ArboreBinar(nod1);
    System.out.println("Arborele contine "+arbore.numarNoduri()+
        " noduri");
    Iterator iter;
    System.out.println("Parcurgere in adancime:");
    iter=arbore.iteratorAdancime();
    while(iter.hasNext())
      System.out.print(iter.next()+" ");
    System.out.println();
    System.out.println("Traversare in preordine:");
    iter=arbore.iteratorPreordine();
    while(iter.hasNext())
      System.out.print(iter.next()+" ");
    System.out.println();
    System.out.println("Traversare in inordine:");
    iter=arbore.iteratorInordine();
    while(iter.hasNext())
      System.out.print(iter.next()+" ");
    System.out.println();
    System.out.println("Traversare in postordine:");
    iter=arbore.iteratorPostordine();
    while(iter.hasNext())
      System.out.print(iter.next()+" ");
    System.out.println();
    System.out.println("Traversare in latime: ");
    iter=arbore.iteratorLatime();
    while(iter.hasNext())
      System.out.print(iter.next()+" ");
    System.out.println();
    System.out.println("Lista in preordine: "+arbore.preordine());
    System.out.println("Lista in inordine: "+arbore.inordine());
    System.out.println("Lista in postordine: "+arbore.postordine());
    System.out.println("Lista in latime: "+arbore.inLatime());
    System.out.println("Arborele convertit in sir:\n"+arbore);
  }
}
