import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class TestJFileChooser {
  GUI gui=new GUI();
  JFileChooser fc;

  class GUI extends JFrame {
    JButton open, save, clear;
    JPanel panel;
    JTextArea ta=new JTextArea();
    AscultButoane ab;

    GUI() {
      super("Selectare de fisiere");
      open=new JButton("Open file");
      save=new JButton("Save file");
      clear=new JButton("Clear");
      panel=new JPanel();
      panel.add(open);
      panel.add(save);
      panel.add(clear);
      Container cp=getContentPane();
      cp.add(panel, BorderLayout.NORTH);
      ab=new AscultButoane();
      open.addActionListener(ab);
      save.addActionListener(ab);
      clear.addActionListener(ab);
      addWindowListener(new Stop());
      fc=new JFileChooser();
      ta=new JTextArea();
      JScrollPane sp=new JScrollPane(ta);
      cp.add(sp, BorderLayout.CENTER);
      setLocation(50, 50);
      setSize(400,200);
      setVisible(true);
    }
  }

  class AscultButoane implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      String actiune=e.getActionCommand();
      int raspuns=-1;
      if(actiune.equals("Clear")) gui.ta.setText("");
      else {
        if(actiune.equals("Open file")) 
          raspuns=fc.showOpenDialog(gui);
        else if(actiune.equals("Save file")) 
          raspuns=fc.showSaveDialog(gui);
        gui.ta.append(actiune+": raspuns="+raspuns+
         " Selectat: "+fc.getName(fc.getSelectedFile())+'\n');   
      }
    }
  }


  class Stop extends WindowAdapter {
    public void windowClosing(WindowEvent e) {
      System.exit(0);
    }
  }

  public static void main(String args[]) {
    TestJFileChooser tfc=new TestJFileChooser();
  }
}

      