import java.util.*;

class TestDijkstra {

  public static void main(String args[]) {
    ArrayList muchiiGraf=new ArrayList();
    String nodSursa=null;
    if(args.length<10) {
      System.out.println("Dati nodul sursa, urmat de cel putin trei muchii "+
          "sub forma: nod1 nod2 lungime");
      System.exit(0);
    }

    try {
      nodSursa=args[0];
      for(int i=1; i<args.length; i+=3)
        muchiiGraf.add(new Dijkstra.Muchie(args[i], args[i+1],
		 Double.parseDouble(args[i+2])));
    }
    catch(Exception e) {
      System.out.println("Eroare in argumente\n"+e);
    }

    Collection solutie=Dijkstra.dijkstra(muchiiGraf, nodSursa); 
    System.out.println("Arborele de acoperire Dijkstra:\n"+solutie);
  }
}