
import java.util.*;

class TestDynProg1 {

  public static void main(String args[]) {
    /* Varianta 1: inmultire matrici 
    String arce[][]={{"A","B"},{"A","C"},{"A","D"},{"B","E"},{"B","F"},{"C","E"},{"C","G"},
         {"D","F"},{"D","G"},{"E","H"},{"F","H"},{"G","H"}};
    double lungimi[]={15, 70, 6, 50, 6, 50, 14, 15, 14, 10, 10, 10};
    */
    /* Varianta cu graf orientat cu cicluri 
    String arce[][]={{"A","B"},{"A","C"},{"A","D"},{"B","A"},{"B","D"},{"C","A"},{"C","D"},
      {"D","A"},{"D","B"},{"D","C"}};
    double lungimi[]={10, 8, 71, 3, 12, 12, 9, 53, 11, 6};
    */
    /* Varianta din Exemplul 1 */
    String arce[][]={{"A","B"},{"A","C"},{"B","D"},{"B","E"},{"C","E"},{"C","F"},{"D","G"},
      {"D","H"},{"E","H"},{"E","I"},{"F","I"},{"F","J"},{"G","K"},{"G","L"},{"H","K"},
      {"H","L"},{"H","M"},{"I","L"},{"I","M"},{"I","N"},{"J","M"},{"J","N"},{"K","O"},
      {"K","P"},{"L","O"},{"L","P"},{"L","R"},{"M","P"},{"M","R"},{"M","S"},{"N","R"},
      {"N","S"}};
    double lungimi[]={1, 2, 2, 1, 1, 2, 3, 3, 4, 2, 3, 3, 2, 4, 4, 1, 6, 7, 1, 6, 5, 2, 1,
      5, 5, 2, 6, 5, 1, 7, 6, 1};
    
    ArrayList listaArce=new ArrayList();
    for(int i=0; i<arce.length; i++) {
      listaArce.add(new DynamicProg1.ArcGraf(arce[i][0], arce[i][1], lungimi[i]));
    }
    System.out.println();
    DynamicProg1.Graf graf=new DynamicProg1.Graf(listaArce);
    System.out.println("Trasare inapoi");
    DynamicProg1.Solutie solutie=DynamicProg1.trasareInapoi(graf, "A", "R");
    System.out.println(solutie);
    System.out.println("Trasare inainte: ");
    solutie=DynamicProg1.trasareInainte(graf, "A", "R");
    System.out.println(solutie);
  }
}